
$crystal = 8000000
$regfile = "attiny85.dat"


Dim X As Word
Dim Y As Word
Dim Sum As Word
Dim Active_new As Bit
Dim Active_old As Bit

Open "comb.0:9600,8,n,1" For Output As #1
Config Adc = Single , Prescaler = Auto                      'Reference = EXTERNAL
Start Adc

Active_new = 0
Active_old = 0

Do
   Gosub Touch

   'see if touchpad is active -----------------------------------------------------
   'x- and y-resistor both make use of internal pullups to ensure full reading of adc, if touchpad not pressed
   Sum = X + Y
   If X < 1015 Then                                         'if one or both of the readings are >= 1015
      If Y < 1015 Then                                      'there is no proper touch detected
         Active_new = 1
      End If
   End If

   If Sum > 2030 Then                                       'both axis are on full scale due to pullups = no touch
      Active_new = 0                                        'any more
   End If

   If Active_new = 1 And Active_old = 0 Then                'new touch
      Waitms 50                                             'wait for stable touch signal
      Gosub Touch
      If X < 1015 Then                                      'check again if
         If Y < 1015 Then                                   'proper touch detected
            Print #1 , X ; "," ;
            Print #1 , Y
            Active_old = 1
         Else
            Active_new = 0
         End If
      Else
         Active_new = 0
      End If
   End If

   If Active_new = 0 And Active_old = 1 Then
      Print #1 , "RELEASE"
      Active_old = 0
   End If
Loop




Touch:
   ' get voltage for x coordinte --------------------------------------------------
   Config Pinb.4 = Input                                    'let y-resistor floating
   Config Pinb.2 = Input
   Set Portb.4                                              'activate pullups
   Set Portb.2
   Config Pinb.3 = Output                                   'x-resistor will be connected to vcc (port b.3)
   Config Pinb.1 = Output                                   'and to GND (port b.1)
   Set Portb.3
   Reset Portb.1
   Waitms 10
   X = Getadc(2)                                            'read x voltage out of one connector of y resistor

   ' get voltage for y coordinte --------------------------------------------------
   Config Pinb.1 = Input                                    'let x-resistor floating
   Config Pinb.3 = Input
   Set Portb.1                                              'activate pullups
   Set Portb.3
   Config Pinb.4 = Output                                   'y-resistor will be connected to vcc (port b.2)
   Config Pinb.2 = Output                                   'and to GND (port b.4)
   Reset Portb.4
   Set Portb.2
   Waitms 10
   Y = Getadc(3)
Return





